﻿function ShowMsg(...)
	return print('|cffFCF75E'..L["addon_name"]..'|r:', ...)
end

-- Slash commands ---------------------------------------------
SLASH_MSS1 = "/mss"
SlashCmdList["MSS"] = function(str)
	local input, input2 = strsplit(" ", str)
	if input == "lock" then 	
		Option_Command_Lock(1)
		ShowMsg("Locked")
	elseif input == "unlock" then
		Option_Command_Lock(0)
		ShowMsg("Unlocked")
	elseif input == "show" then
		Option_Command_EnableMSS(1)
		Option_Command_EnableTalentBar(1)
	elseif input == "hide" then
		Option_Command_EnableMSS(0)
		Option_Command_EnableTalentBar(0)
	else
		InterfaceOptionsFrame_OpenToCategory(MSS_OptionsPanel)
		ShowMsg("/mss lock 锁定")
		ShowMsg("/mss unlock - 解锁")
		ShowMsg("/mss show - 显示")
		ShowMsg("/mss hide - 隐藏")
		
	end
end

-- Option Persistance    -------------------------------------------------------------
function OptionsPanel_OnLoad(panel)	
	panel.name = "Master Shape Shifter";		
	panel.okay = function(self) end	
	-- panel.cancel = function (self) end	
	InterfaceOptions_AddCategory(panel);	
end

-- Load from saved variables
function LoadOptions(self, event, ...) 
	local name = select(1, ...)
	if event == "ADDON_LOADED" and name == "MasterShapeShifter" then	
		
		-- Default values
		if not MSS_SavedOptions then	
			MSS_SavedOptions = {}
			MSS_SavedOptions["lock"] = 0
			MSS_SavedOptions["talent_timer_pos"] = "top"
			MSS_SavedOptions["enable_mss"] = 1
			MSS_SavedOptions["enable_talentbar"] = 1
			MSS_SavedOptions["detach"] = 0
			MSS_SavedOptions["hide_no_combat"] = 0
			MSS_SavedOptions["lock_float_icon"] = 1
			MSS_SavedOptions["ui_scale"] = 1.0
			ShowMsg("No profile found. Set to default")
		end
		
		-- Loading
		Option_Command_Lock(MSS_SavedOptions["lock"])		
		Option_Command_Talent_TimerPos(MSS_SavedOptions["talent_timer_pos"])
		Option_Command_EnableMSS(MSS_SavedOptions["enable_mss"])		
		Option_Command_EnableTalentBar(MSS_SavedOptions["enable_talentbar"])		
		Option_Command_Detach(MSS_SavedOptions["detach"])
		Option_Command_HideNoCombat(MSS_SavedOptions["hide_no_combat"])	
		Option_Command_LockFloatIcon(MSS_SavedOptions["lock_float_icon"])	
		
		Option_Command_SetScale(MSS_SavedOptions["ui_scale"])	
		
		
	
	end
end

-- Option commands -------------
function Option_Command_Lock(flag)
	MSS_SavedOptions["lock"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_Lock:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_Lock:SetChecked(false)
	end
	
	if flag == 1 then -- lock
		MasterSSMask:RegisterForDrag("")
		MSS_TalentBar:RegisterForDrag("")	
		MasterSS_ComboFrame:RegisterForDrag("")		
		
		MasterSSMask:EnableMouse(false)
		MasterSS:EnableMouse(false)
		MasterSS_ComboFrame:EnableMouse(false)
	else --unlock
		MasterSSMask:RegisterForDrag("LeftButton")
		MSS_TalentBar:RegisterForDrag("LeftButton")
		if MSS_SavedOptions["detach"] == 1 then
			MasterSS_ComboFrame:RegisterForDrag("LeftButton")		
		end		
		MasterSSMask:EnableMouse(true)
		MasterSS:EnableMouse(true)
		MasterSS_ComboFrame:EnableMouse(true)
	end
end

function Option_Command_Talent_TimerPos(pos)
	MSS_SavedOptions["talent_timer_pos"] = pos
	if pos == "top" then
		MSS_OptionPanel_CheckButton_TalentTimerPos:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_TalentTimerPos:SetChecked(false)
	end
	
	if pos == "top" then
		MSS_TalentBar_TimeMask3:SetPoint("CENTER", MSS_TalentButton3, "CENTER", 0, 27)
		MSS_TalentBar_TimeMask4:SetPoint("CENTER", MSS_TalentButton4, "CENTER", 0, 27)
		MSS_TalentBar_TimeMask5:SetPoint("CENTER", MSS_TalentButton5, "CENTER", 0, 27)	
	else 
		MSS_TalentBar_TimeMask3:SetPoint("CENTER", MSS_TalentButton3, "CENTER", 0, -27)
		MSS_TalentBar_TimeMask4:SetPoint("CENTER", MSS_TalentButton4, "CENTER", 0, -27)
		MSS_TalentBar_TimeMask5:SetPoint("CENTER", MSS_TalentButton5, "CENTER", 0, -27)	
	end
end

local function SetVisible(id, flag)
	if id == "talentbar" then
		if flag == 0 then			
			MSS_TalentBar:Hide()
			MSS_TalentButton1:Hide()
			MSS_TalentButton2:Hide()
			MSS_TalentButton3:Hide()
			MSS_TalentButton4:Hide()
			MSS_TalentButton5:Hide()
			MSS_TalentButton6:Hide()			
		else 
			MSS_TalentBar:Show()
			MSS_TalentButton1:Show()
			MSS_TalentButton2:Show()
			MSS_TalentButton3:Show()
			MSS_TalentButton4:Show()
			MSS_TalentButton5:Show()
			MSS_TalentButton6:Show()
		end
		
	elseif id == "portrait" then
		if flag == 0 then
			MasterSSMask:Hide()
			MasterSS:Hide()			
		else 
			MasterSSMask:Show()
			MasterSS:Show()			
		end		
	end
end

function Option_Command_EnableMSS(flag)
	MSS_SavedOptions["enable_mss"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_EnableMSS:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_EnableMSS:SetChecked(false)
	end	
	SetVisible("portrait", flag)
end

function Option_Command_EnableTalentBar(flag)
	MSS_SavedOptions["enable_talentbar"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_EnableTalentBar:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_EnableTalentBar:SetChecked(false)
	end	
	SetVisible("talentbar", flag)
end

function Option_Command_Detach(flag)
	MSS_SavedOptions["detach"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_DetachComboFrame:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_DetachComboFrame:SetChecked(false)
	end
	
	if flag == 1 then
		MasterSS_ComboFrame:ClearAllPoints()	
		if MSS_SavedOptions["lock"] == 0 then
				MasterSS_ComboFrame:RegisterForDrag("LeftButton")		
		end
	else 
		MasterSS_ComboFrame:ClearAllPoints()
		MasterSS_ComboFrame:SetPoint("BOTTOMRIGHT", MasterSS, "TOPRIGHT", -20, -15)
		MasterSS_ComboFrame:RegisterForDrag("")		
	end
end

function Option_Command_HideNoCombat(flag)
	MSS_SavedOptions["hide_no_combat"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_HideNoCombat:SetChecked(true)
		MasterSS:Hide()
		MasterSSMask:Hide()
	else
		MSS_OptionPanel_CheckButton_HideNoCombat:SetChecked(false)
		MasterSS:Show()
		MasterSSMask:Show()
	end
end

function Option_Command_LockFloatIcon(flag) 
	MSS_SavedOptions["lock_float_icon"] = flag
	local f = flag == 1
	MSS_OptionPanel_CheckButton_LockFloatIcon:SetChecked(f)
	
	if flag ==1 then
		MSS_Float_PreditorySwiftness:EnableMouse(false)
		MSS_Float_DoC:EnableMouse(false)		
	else 
		MSS_Float_PreditorySwiftness:EnableMouse(true)
		MSS_Float_DoC:EnableMouse(true)
		MSS_Float_PreditorySwiftness:RegisterForDrag("LeftButton")
		MSS_Float_DoC:RegisterForDrag("LeftButton")
	end
end

function Option_Command_SetScale(value)	
	MSS_OptionPanel_UISlider:SetValue(value)
end




